% main for Bayes factor detection of
% periodic signal components
% COURSE 02581 Computational Data Analysis
% Illustration of advanced Bayes detectors
% (c) L.K. Hansen 2003
%
load letters % Matlab stucture with sounds for letters a-z
figure(1)
subplot(4,1,1),plot(letters.a1), title('Time funtion for letter a')
subplot(4,1,2),plot(letters.b1), title('Time funtion for letter b')
subplot(4,1,3),plot(letters.c1), title('Time funtion for letter c')
subplot(4,1,4),plot(letters.d1), title('Time funtion for letter d')
wmin=0.005;
wmax=0.10;   %0.5 = fs/2 = 5kHz
Nw=200;
K=4;
% create overlapping windows
x=letters.c1;
M=length(x);
clas=zeros(M,1);
W=256;
Q=floor(M/W);
E=zeros(Nw,Q);
for j=1:Q;
    disp(['Doing j=',int2str(j),' of ',int2str(Q)])
    indx=((j-1)*W+1):(j*W);
    y=x(indx);
    [logP,logP0]=bspect(y,wmin,wmax,Nw,1,K,1);
    ;
    Pmax=max(max(logP));
    Pmax=max(Pmax,logP0);
    Pmarginal=sum(exp(logP-Pmax),2); %sum over K
    %E(:,j)=Pmarginal/sum(Pmarginal);
    normlogP=[exp(logP0-Pmax),Pmarginal'];
    normlogP=normlogP/sum(normlogP);
    E(:,j)=normlogP(2:end)';  
    Per=1-normlogP(1);
    clas(indx)=Per*ones(size(indx));
end
figure(2)
subplot(2,1,1),plot(x), title('Time funtion for letter c1')
subplot(2,1,2),plot(clas), title('Prob. of presence periodic component')
%figure(3)  % probabilities frequency vs time sm. spectrum
%imagesc(E);
    
    
    
    